<?php
// +-----------------------------------------------------------------------+
// | Files statistics - a PWG Plugin                                       |
// | Copyright (C) 2007 Ruben ARNAUD - rub@phpwebgallery.net               |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

if (!defined('PHPWG_ROOT_PATH'))
{
  die('Hacking attempt!');
}

function plugin_install()
{
  include_once(dirname(__FILE__).'/constants.php');

  @mkdir(FSTATS_DATA_DIR);
  @mkdir(FSTATS_RAW_DIR);
  @mkdir(FSTATS_SUMMARY_DIR);
  $filename = FSTATS_DATA_DIR.'/.htaccess';
  $hfile = fopen($filename, 'w+');
  if ($hfile !== FALSE)
  {
    fwrite($hfile, 'deny from all');
    fclose($hfile);
  }
}

function plugin_activate()
{
  global $conf;

  if (!empty($conf['fstat_plugin_activate_migrate']) and $conf['fstat_plugin_activate_migrate'])
  {
    include_once(dirname(__FILE__).'/constants.php');
    include_once(FSTATS_PLUGIN_DIR.'/functions.inc.php');

    @set_time_limit(0);

    // HISTORY_TABLE
    $query = 'select * from '.HISTORY_TABLE.' order by date, time, user_id';

    $result = pwg_query($query);

    $year = null;
    $month = null;
    $day = null;
    $hour = null;
    $user_id = null;
    $filename = null;
    $hfile = FALSE;

    while ($row = mysql_fetch_array($result))
    {
      if ($year.'_'.$month.'_'.$day.'_'.$hour.'_'.$user_id != $row['year'].'_'.$row['month'].'_'.$row['day'].'_'.$row['hour'].'_'.$row['user_id'])
      {
        if ($hfile !== FALSE)
        {
          fclose($hfile);
        }

        $year = $row['year'];
        $month = $row['month'];
        $day = $row['day'];
        $hour = $row['hour'];
        $user_id = $row['user_id'];

        $dirname = sprintf(FSTATS_FMT_RAW_DIR_H, $year, $month, $day, $hour);

        fstats_Rmkdir($dirname);

        $filename = $dirname.'/'.sprintf(FSTATS_FMT_RAW_FILE, $year, $month, $day, $hour, $user_id);
        $hfile = fopen($filename, 'w+');
      }

      $row['version'] = '0';
      if ($hfile !== FALSE)
      {
        fwrite($hfile, serialize ($row)."\n");
      }
    }

    if ($hfile !== FALSE)
    {
      fclose($hfile);
    }
    // HISTORY_SUMMARY_TABLE
    $query = 'select * from '.HISTORY_SUMMARY_TABLE.' order by year, month, day, hour';

    $result = pwg_query($query);

    $year = null;
    $month = null;
    $day = null;
    $hour = null;
    $filename = null;
    $hfile = FALSE;

    while ($row = mysql_fetch_array($result))
    {
      if ($year.'_'.$month.'_'.$day.'_'.$hour != $row['year'].'_'.$row['month'].'_'.$row['day'].'_'.$row['hour'])
      {
        if ($hfile !== FALSE)
        {
          fclose($hfile);
        }

        $year = $row['year'];
        $month = $row['month'];
        $day = $row['day'];
        $hour = $row['hour'];

        $dirname = sprintf(FSTATS_FMT_SUMMARY_DIR, $year, $month, $day, $hour);

        fstats_Rmkdir($dirname);

        $filename = $dirname.'/'.sprintf(FSTATS_FMT_SUMMARY_FILE, $year, $month, $day, $hour);
        $hfile = fopen($filename, 'w+');
      }

      $row['version'] = '0';
      if ($hfile !== FALSE)
      {
        fwrite($hfile, serialize ($row)."\n");
      }
    }

    if ($hfile !== FALSE)
    {
      fclose($hfile);
    }
  }
}

?>